%global __provides_exclude_from %{_docdir}
%global __requires_exclude_from %{_docdir}
%global ssldir %{_sysconfdir}/pki/%{name}
%global restart_flag /run/%{name}/%{name}-restart-after-rpm-install
%global _hardened_build 1
%global pigeonholever 0.5.19

Summary: Secure imap and pop3 server
Name:    dovecot
Version: 2.3.19.1
Release: 8%{?dist}
License: MIT and LGPLv2
URL:     https://www.dovecot.org/
Source0: https://www.dovecot.org/releases/2.3/%{name}-%{version}.tar.gz
Source1: https://pigeonhole.dovecot.org/releases/2.3/dovecot-2.3-pigeonhole-%{pigeonholever}.tar.gz
Source2: dovecot.pam
Source3: dovecot.tmpfilesd
Source4: dovecot.conf.5
Source5: prestartscript

Patch3001: dovecot-2.0-defaultconfig.patch
Patch3002: dovecot-1.0.beta2-mkcert-permissions.patch
Patch3003: dovecot-1.0.rc7-mkcert-paths.patch
Patch3004: dovecot-2.1.10-waitonline.patch
Patch3005: dovecot-2.2.20-initbysystemd.patch
Patch3006: dovecot-2.2.22-systemd_w_protectsystem.patch
Patch3007: dovecot-2.3.11-bigkey.patch
Patch3008: dovecot-2.3.6-opensslhmac.patch
Patch3009: dovecot-2.3.15-fixvalcond.patch
Patch3010: dovecot-2.3.15-valbasherr.patch
Patch3011: dovecot-2.3.14-opensslv3.patch
Patch3012: dovecot-2.3.19.1-7bad6a24.patch

BuildRequires: gcc gcc-c++ openssl-devel pam-devel zlib-devel bzip2-devel libcap-devel
BuildRequires: libtool autoconf automake pkgconfig sqlite-devel libpq-devel make
BuildRequires: mariadb-connector-c-devel libxcrypt-devel openldap-devel krb5-devel quota-devel xz-devel
BuildRequires: lz4-devel libzstd-devel libicu-devel libexttextcat-devel libstemmer-devel flex bison
BuildRequires: systemd-devel systemd-rpm-macros gettext-devel clucene-core-devel libcurl-devel expat-devel
BuildRequires: libsodium-devel lua-devel
Requires: openssl systemd
Requires(pre): shadow-utils
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

%description
Dovecot is an IMAP server for Linux/UNIX-like systems, written with security primarily in mind.  It
also contains a small POP3 server.  It supports mail in either of maildir or mbox formats.

The SQL drivers and authentication plug-ins are in their subpackages.

%package pigeonhole
Summary: Sieve and managesieve plug-in for dovecot
License: MIT and LGPLv2
Requires: %{name} = %{version}-%{release}

%description pigeonhole
This package provides sieve and managesieve plug-in for dovecot LDA.

%package pgsql
Summary: Postgres SQL back end for dovecot
Requires: %{name} = %{version}-%{release}

%description pgsql
This package provides the Postgres SQL back end for dovecot-auth etc.

%package mysql
Summary: MySQL back end for dovecot
Requires: %{name} = %{version}-%{release}

%description mysql
This package provides the MySQL back end for dovecot-auth etc.

%package devel
Summary: Development files for dovecot
Requires: %{name} = %{version}-%{release}

%description devel
This package provides the development files for dovecot.

%prep
%autosetup -n %{name}-%{version} -p1 -a1
cp run-test-valgrind.supp dovecot-2.3-pigeonhole-%{pigeonholever}/
echo "testsuite" >dovecot-2.3-pigeonhole-%{pigeonholever}/run-test-valgrind.exclude

sed -i '/DEFAULT_INCLUDES *=/s|$| '"$(pkg-config --cflags libclucene-core)|" src/plugins/fts-lucene/Makefile.in

# bypass test about time
sed -e '/test_multi_ip_attempts,/d' \
    -e '/test_connection_timed_out,/d' \
    -i src/lib-http/test-http-client-errors.c

%build
export CFLAGS="%{__global_cflags} -fno-strict-aliasing -fstack-reuse=none"
export LDFLAGS="-Wl,-z,now -Wl,-z,relro %{?__global_ldflags}"
mkdir -p m4
autoreconf -I . -fiv
%configure                       \
    INSTALL_DATA="install -c -p -m644" \
    --with-rundir=%{_rundir}/%{name}   \
    --with-systemd               \
    --docdir=%{_pkgdocdir}       \
    --disable-static             \
    --disable-rpath              \
    --with-nss                   \
    --with-shadow                \
    --with-pam                   \
    --with-gssapi=plugin         \
    --with-ldap=plugin           \
    --with-sql=plugin            \
    --with-pgsql                 \
    --with-mysql                 \
    --with-sqlite                \
    --with-zlib                  \
    --with-zstd                  \
    --with-libcap                \
    --with-icu                   \
    --with-lua=plugin            \
    --with-lucene                \
    --with-ssl=openssl           \
    --with-ssldir=%{ssldir}      \
    --with-solr                  \
    --with-docs                  \
    systemdsystemunitdir=%{_unitdir}

sed -i 's|/etc/ssl|/etc/pki/dovecot|' doc/mkcert.sh doc/example-config/conf.d/10-ssl.conf

%make_build

pushd dovecot-2*3-pigeonhole-%{pigeonholever}

[ -f configure ] || autoreconf -fiv
[ -f ChangeLog ] || echo "Pigeonhole ChangeLog is not available, yet" >ChangeLog

%configure                             \
    INSTALL_DATA="install -c -p -m644" \
    --disable-static                   \
    --with-dovecot=../                 \
    --without-unfinished-features

%make_build
popd

%install
rm -rf %{buildroot}

%make_install

mv %{buildroot}/%{_pkgdocdir} %{_builddir}/%{name}-%{version}/docinstall

pushd dovecot-2*3-pigeonhole-%{pigeonholever}
%make_install

mv %{buildroot}/%{_pkgdocdir} %{buildroot}/%{_docdir}/%{name}-pigeonhole

install -m 644 AUTHORS ChangeLog COPYING COPYING.LGPL INSTALL NEWS README %{buildroot}/%{_docdir}/%{name}-pigeonhole
popd

install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/dovecot
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_mandir}/man5/dovecot.conf.5
install -p -D -m 755 %{SOURCE5} %{buildroot}%{_libexecdir}/dovecot/prestartscript

mkdir -p %{buildroot}%{ssldir}/certs
mkdir -p %{buildroot}%{ssldir}/private
touch %{buildroot}%{ssldir}/certs/dovecot.pem
chmod 600 %{buildroot}%{ssldir}/certs/dovecot.pem
touch %{buildroot}%{ssldir}/private/dovecot.pem
chmod 600 %{buildroot}%{ssldir}/private/dovecot.pem

install -p -D -m 644 %{SOURCE3} %{buildroot}%{_tmpfilesdir}/dovecot.conf

mkdir -p %{buildroot}/run/dovecot/{login,empty,token-login}

mkdir -p %{buildroot}%{_sysconfdir}/dovecot/conf.d
install -p -m 644 docinstall/example-config/dovecot.conf \
    %{buildroot}%{_sysconfdir}/dovecot
install -p -m 644 docinstall/example-config/conf.d/*.conf \
    %{buildroot}%{_sysconfdir}/dovecot/conf.d
install -p -m 644 %{buildroot}/%{_docdir}/%{name}-pigeonhole/example-config/conf.d/*.conf \
    %{buildroot}%{_sysconfdir}/dovecot/conf.d
install -p -m 644 docinstall/example-config/conf.d/*.conf.ext \
    %{buildroot}%{_sysconfdir}/dovecot/conf.d
install -p -m 644 %{buildroot}/%{_docdir}/%{name}-pigeonhole/example-config/conf.d/*.conf.ext \
    %{buildroot}%{_sysconfdir}/dovecot/conf.d ||:
install -p -m 644 doc/dovecot-openssl.cnf \
    %{buildroot}%{ssldir}/dovecot-openssl.cnf
install -p -m755 doc/mkcert.sh \
    %{buildroot}%{_libexecdir}/%{name}/mkcert.sh

mkdir -p %{buildroot}/var/lib/dovecot

find %{buildroot}%{_libdir}/%{name}/ -name '*.la' | xargs rm -f

rm -f %{buildroot}%{_sysconfdir}/dovecot/README
pushd docinstall
rm -f securecoding.txt thread-refs.txt
popd

%pre
getent group dovecot >/dev/null || groupadd -r --gid 97 dovecot
getent passwd dovecot >/dev/null || \
useradd -r --uid 97 -g dovecot -d /usr/libexec/dovecot -s /sbin/nologin -c "Dovecot IMAP server" dovecot

getent group dovenull >/dev/null || groupadd -r dovenull
getent passwd dovenull >/dev/null || \
useradd -r -g dovenull -d /usr/libexec/dovecot -s /sbin/nologin -c "Dovecot's unauthorized user" dovenull

if [ "$1" = "2" ]; then
  rm -f %restart_flag
  /bin/systemctl is-active %{name}.service >/dev/null 2>&1 && touch %restart_flag ||:
  /bin/systemctl stop %{name}.service >/dev/null 2>&1
fi

%post
if [ $1 -eq 1 ]
then
  %systemd_post dovecot.service
fi

install -d -m 0755 -g dovecot -d /run/dovecot
install -d -m 0755 -d /run/dovecot/empty
install -d -m 0750 -g dovenull -d /run/dovecot/login
install -d -m 0750 -g dovenull -d /run/dovecot/token-login
[ -x /sbin/restorecon ] && /sbin/restorecon -R /run/dovecot ||:

%preun
if [ $1 = 0 ]; then
        /bin/systemctl disable dovecot.service dovecot.socket >/dev/null 2>&1 || :
        /bin/systemctl stop dovecot.service dovecot.socket >/dev/null 2>&1 || :
    rm -rf /run/dovecot
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :

if [ "$1" -ge "1" -a -e %restart_flag ]; then
    /bin/systemctl start dovecot.service >/dev/null 2>&1 || :
rm -f %restart_flag
fi

%posttrans
if [ -e %restart_flag ]; then
    /bin/systemctl start dovecot.service >/dev/null 2>&1 || :
rm -f %restart_flag
fi

%check
%ifnarch aarch64
make check
cd dovecot-2*3-pigeonhole-%{pigeonholever}
make check
%endif

%files
%license COPYING COPYING.LGPL COPYING.MIT
%doc docinstall/* AUTHORS ChangeLog NEWS README
%_tmpfilesdir/dovecot.conf
%{_unitdir}/dovecot.service
%{_unitdir}/dovecot-init.service
%{_unitdir}/dovecot.socket
%dir %{_sysconfdir}/dovecot
%dir %{_sysconfdir}/dovecot/conf.d
%config(noreplace) %{_sysconfdir}/dovecot/dovecot.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-auth.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-director.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-logging.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-mail.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-master.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-metrics.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/10-ssl.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/15-lda.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/15-mailboxes.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/20-imap.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/20-lmtp.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/20-pop3.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/20-submission.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/90-acl.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/90-quota.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/90-plugin.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-checkpassword.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-deny.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-dict.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-ldap.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-master.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-passwdfile.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-sql.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-static.conf.ext
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/auth-system.conf.ext
%config(noreplace) %{_sysconfdir}/pam.d/dovecot
%config(noreplace) %{ssldir}/dovecot-openssl.cnf
%dir %{ssldir}
%dir %{ssldir}/certs
%dir %{ssldir}/private
%attr(0600,root,root) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{ssldir}/certs/dovecot.pem
%attr(0600,root,root) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{ssldir}/private/dovecot.pem
%{_sbindir}/dovecot
%{_bindir}/doveadm
%{_bindir}/doveconf
%{_bindir}/dsync
%{_bindir}/dovecot-sysreport
%dir %{_libdir}/dovecot
%dir %{_libdir}/dovecot/auth
%dir %{_libdir}/dovecot/dict
%{_libdir}/dovecot/doveadm
%{_libdir}/dovecot/*.so.*
%{_libdir}/dovecot/*_plugin.so
%{_libdir}/dovecot/auth/lib20_auth_var_expand_crypt.so
%{_libdir}/dovecot/auth/libauthdb_imap.so
%{_libdir}/dovecot/auth/libauthdb_ldap.so
%{_libdir}/dovecot/auth/libauthdb_lua.so
%{_libdir}/dovecot/auth/libmech_gssapi.so
%{_libdir}/dovecot/auth/libdriver_sqlite.so
%{_libdir}/dovecot/dict/libdriver_sqlite.so
%{_libdir}/dovecot/dict/libdict_ldap.so
%{_libdir}/dovecot/libdriver_sqlite.so
%{_libdir}/dovecot/libssl_iostream_openssl.so
%{_libdir}/dovecot/libfs_compress.so
%{_libdir}/dovecot/libfs_crypt.so
%{_libdir}/dovecot/libfs_mail_crypt.so
%{_libdir}/dovecot/libdcrypt_openssl.so
%{_libdir}/dovecot/lib20_var_expand_crypt.so
%{_libdir}/dovecot/old-stats/libold_stats_mail.so
%{_libdir}/dovecot/old-stats/libstats_auth.so
%dir %{_libdir}/dovecot/settings
%{_libexecdir}/%{name}
%dir %attr(0755,root,dovecot) %ghost /run/dovecot
%attr(0750,root,dovenull) %ghost /run/dovecot/login
%attr(0750,root,dovenull) %ghost /run/dovecot/token-login
%attr(0755,root,root) %ghost /run/dovecot/empty
%attr(0750,dovecot,dovecot) /var/lib/dovecot
%{_datadir}/%{name}
%{_mandir}/man1/deliver.1*
%{_mandir}/man1/doveadm*.1*
%{_mandir}/man1/doveconf.1*
%{_mandir}/man1/dovecot*.1*
%{_mandir}/man1/dsync.1*
%{_mandir}/man5/dovecot.conf.5*
%{_mandir}/man7/doveadm-search-query.7*
%exclude %{_libdir}/dovecot/doveadm/*sieve*
%exclude %{_libdir}/dovecot/*_sieve_plugin.so
%exclude %{_libexecdir}/%{name}/managesieve*

%files devel
%{_includedir}/dovecot
%{_libdir}/dovecot/libdovecot*.so
%{_libdir}/dovecot/dovecot-config
%{_datadir}/aclocal/dovecot*.m4

%files pigeonhole
%{_docdir}/%{name}-pigeonhole
%{_bindir}/sieve-dump
%{_bindir}/sieve-filter
%{_bindir}/sieve-test
%{_bindir}/sievec
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/20-managesieve.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/90-sieve.conf
%config(noreplace) %{_sysconfdir}/dovecot/conf.d/90-sieve-extprograms.conf
%{_libexecdir}/%{name}/managesieve
%{_libexecdir}/%{name}/managesieve-login
%{_libdir}/dovecot/doveadm/*sieve*
%{_libdir}/dovecot/*_sieve_plugin.so
%{_libdir}/dovecot/settings/libmanagesieve_*.so
%{_libdir}/dovecot/settings/libpigeonhole_*.so
%{_libdir}/dovecot/sieve/
%{_mandir}/man1/sieve-dump.1*
%{_mandir}/man1/sieve-filter.1*
%{_mandir}/man1/sieve-test.1*
%{_mandir}/man1/sievec.1*
%{_mandir}/man1/sieved.1*
%{_mandir}/man7/pigeonhole.7*

%files mysql
%{_libdir}/%{name}/libdriver_mysql.so
%{_libdir}/%{name}/auth/libdriver_mysql.so
%{_libdir}/%{name}/dict/libdriver_mysql.so

%files pgsql
%{_libdir}/%{name}/libdriver_pgsql.so
%{_libdir}/%{name}/auth/libdriver_pgsql.so
%{_libdir}/%{name}/dict/libdriver_pgsql.so

%changelog
* Wed Dec 27 2023 Rebuild Robot <rebot@opencloudos.org> - 2.3.19.1-8
- Rebuilt for libsodium

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.3.19.1-7
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 rockerzhu <rockerzhu@tencent.com> - 2.3.19.1-6
- Rebuilt for icu 73.2

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 2.3.19.1-5
- Rebuilt for mariadb-connector-c 3.3.5

* Thu Aug 3 2023 Shuo Wang <abushwang@tencent.com> - 2.3.19.1-4
- Rebuilt for libpq 15.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.3.19.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.3.19.1-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 27 2023 Shuo Wang <abushwang@tencent.com> - 2.3.19.1-1
- initial build
